<?php
// Ignium 1.1.0 by iignotus {at]] gmail .dot com (Ignis Ignotus)
// See FEATURES, LICENSE, TODO, and README for more information.

// What should be displayed in the browser's titlebar for this page? ("Ignium Image Board"):
$board_title = 
"Ignium Image Board";

// What CSS style should be used as default if one has not been passed? ("orange.css"):
$board_default_style = 
"grey.css"; 

// What should the page's heading be? ("Ignium Image Board"):
$board_heading = 
"Ignium Image Board";

// What should be the default sans-serif font? ("sans-serif"):
$font_sans_serif = 
"sans-serif";

// What should be the default monospace font? ("monospace"):
$font_monospace = 
"monospace";

// What should the maximum upload size allowable be, in bytes? (5050505):
$max_upload_size = 
5050505;

// How many pages should be accessible/backlogged? (10):
$number_of_pages = 
10;

// How many threads per page should be shown (15):
$threads_per_page = 
15;

// What should the default name of a poster be if none is given? ("Anonymous Coward"):
$default_name_ws = 
"Anonymous Coward";

// What should the default subject title be if none is given? ("No Subject"):
$default_subject_title_ws = 
"No Subject";

// What should the default password be if none is given? ("password"):
$default_pass_ws = 
"password";

// What should the default comment be if none is given? ("No Comment Supplied."):
$default_comment = 
"No Comment Supplied.";

// What is the POST page (JUST HIT ENTER IF AT ALL UNSURE!)? ("post.php"):
$php_post_page = 
"post.php";

// Should logs of who accesses this page be written? (true):
$do_logs = 
true;

// How many lines of text should be shown on the page for each thread (0 means unlimited)? (8):
$thread_body_limit = 
8;

// How many lines of text should be shown on the page for each reply (0 means unlimited)? (6):
$reply_body_limit = 
6;

// What message should be shown for threads that have been shortened on the front page?
$full_body_message = 
"<br />--<br /><strong><i><font color=\"#888888\">The rest of this post has been ommited due to length. Click 'Reply' to view it in its  entirety.</font></i><strong>";

// What should the log file for page access logs be (DEFAULT RECOMMENDED)? ("log/who-up.txt"):
$txt_who_file =
"log/who-up.txt";

// What should the log file for threads to display be (DEFAULT RECOMMENDED!)? ("log/threads.txt"):
$txt_log_file =
"log/threads.txt";

// What is the base-directory for 'data' (DEFAULT STRONGLY RECOMMENDED)? ('data'):
$dir_data_base =
'data';

// What are the rules for the page in an html <ul><li> format (DEFAULT RECOMMENDED)?
$rules =
"Rules:<br /><ul><li>Use Common Sense and Follow the Laws of the Country this Board Resides in.</li></ul>";

// What should the footer of the page be (html allowed, DEFAULT STRONGLY RECOMMENDED)?
$footer =
"<hr width=\"100%\"><table border=\"0\" cellpadding=\"0\"><tr><td><a href=\"http://www.spreadfirefox.com/?q=affiliates&amp;id=116733&amp;t=55\"><img border=\"0\" alt=\"Rediscover the Web!\" title=\"Get Firefox!\" src=\"getffxsm.png\" /></a></td><td valign=\"middle\"><font align=\"center\" size=\"-1\" face=\"sans-serif\" color=\"#888888\">&nbsp;QOTD --  \"<a href=\"ignium.sourceforge.net\">Ignium Version 1.1.0</a> by Ignis Ignotus, (c) 2005 Licensed under the GPL\"</font></td></tr></table>";
		
/* ---------------------------------------END VARIABLE DECLARATIONS------------------------------------------- */

	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">";
	echo "<html>";
	echo "<head>";
	echo "<title>$board_title</title>";
	
	$current_page = $_GET['page'];
	if (!($current_page))
	{
		$current_page = 1;
	}
	
	$style = $_GET['style'];
	if ($style == "")
	{
		$style = $board_default_style;
	}
	if ($_COOKIE['style']) // If cookies have been allowed
	{
		setcookie('style', $style, time()+60*60*24*7, '/', $PHP_SELF);
		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".$_COOKIE['style']."\" />";
	}
	else
	{
		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"$style\" />";
	}
	echo "</head>";	
	echo "<body>";
	
	if ($do_logs == true)
	{
		// Print out the whois info to a log file:
		$srv_date = date("r, U");
		$srv_nfo= "Remote Port: " . $_SERVER["REMOTE_PORT"] . "\n" .
			  "Connection Type: " . $_SERVER["HTTP_CONNECTION"] . "\n" .
			  "Request Time: " . $_SERVER["REQUEST_TIME"] . "\n" .
			  "Current Time: " . $srv_date . "\n" .
			  "IP Address: " . $_SERVER["REMOTE_ADDR"] . "\n" .
			  "Referer: " . $_SERVER["HTTP_REFERER"]. "\n" .
			  "Browser: " . $_SERVER["HTTP_USER_AGENT"] . "\n" .
			  "Requested File: " . $_SERVER["REQUEST_URI"] . "\n\n";
		$who_up=fopen($txt_who_file,"a");
		fwrite($who_up, $srv_nfo);
		fclose($who_up);
	}
	
	echo "<div class=\"pageheading\">$board_heading</div><br />";
	
	// Miniature-greeting below the heading, displays the user's information:
	echo "<div align=\"center\" class=\"greeting\">Welcome, ".$_SERVER["REMOTE_ADDR"].", from ".$_SERVER["HTTP_REFERER"]." !<br />
	You're using ".$_SERVER["HTTP_USER_AGENT"]."<br /><br />";
	
	// Upload form with name, topic, image, and password (for pseudo-identification only):
	echo "<form name=\"upload\" id=\"upload\" action=$php_post_page enctype=\"multipart/form-data\" method=\"post\">
	<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=$max_upload_size>
	<table cellpadding=0 cellspacing=0 border=0>
	  <tr>
	    <td align=\"left\" class=\"tlabel\">
	      Name&nbsp;
	    </td>
	    <td align=\"left\">
	      <input type=\"text\" id=\"name\" name=\"name\" size=\"63\" />
	    </td>
	  </tr>
	  <tr>
	    <td align=\"left\" class=\"tlabel\">
	      Topic&nbsp;
	    </td>
	    <td align=\"left\">
	      <input type=\"text\" id=\"topic\" name=\"topic\" size=\"63\" />
	    </td>
	  </tr>
	  <tr>
	    <td align=\"left\" class=\"tlabel\">
	      Image&nbsp;
	    </td>
	    <td align=\"left\">
	      <input type=\"file\" id=\"userfile\" name=\"userfile\" size=\"50\" />
	    </td>
	  </tr>
	  <tr>
	    <td align=\"left\" class=\"tlabel\">
	      Pass&nbsp;
	    </td>
	    <td align=\"left\">
	      <input type=\"password\" id=\"pass\" name=\"pass\" size=\"55\">
		<input type=\"submit\" name=\"upload\" value=\"Post\">
	    </td>
	  </tr>
	  <tr>
	    <td align=\"left\" class=\"tlabel\">
	      Comment&nbsp;
            </td>
            <td align=\"left\">
              <textarea name=\"comment\" id=\"comment\" cols=\"62\" rows=\"3\"></textarea>
	    </td>
	  </tr>
	</table>
	</form>
        </div>";
	
	// Stylesheet selector
	echo "<div align=\"center\" class=\"smalltext\"><form action=\"up.php?page=$current_page\" method=\"get\">
	<table cellpadding=0 cellspacing=0 border=0><tr><td>Style&nbsp;</td><td>
	<input type=\"radio\" name=\"style\" value=\"green.css\" />Green
	<input type=\"radio\" name=\"style\" value=\"futaba.css\" />Futaba
	<input type=\"radio\" name=\"style\" value=\"orange.css\" />Orange
	<input type=\"radio\" name=\"style\" value=\"grey.css\" />Grey
	<input type=\"radio\" name=\"style\" value=\"xp.css\" />XP
	<input type=\"radio\" name=\"style\" value=\"rose.css\" />Rose&nbsp;
	<input type=\"submit\" name=\"submit\" value=\"Change Style\" /></td></tr></div>";
	
	// Echo the r00lz for the web board:
        echo "<table border=0 cellpadding=0 cellspacing=0 width=\"33%\"><tr><td aling=\"left\">";
	echo "<div class=\"smalltext\">";
	echo $rules;
	echo "</div></td></tr></table></div>";
	
	// Echo the page numbers:
	echo "<div align=\"center\" class=\"styles\">";
	for ($p = 1; $p <= $number_of_pages; $p++)
	{
		echo "<a href=\"up.php?page=$p&style=$style\">";
		if ($p == $_GET['page'])
		{
			echo "<strong>[$p]</strong>";
		}
		else
		{
			echo "[$p]";
		}
		echo "</a>";
	}
	echo "</div>";
	/*
		$openfile is constructed as so:
		[0]==<$imagefile_name>
		[1]==<$marked_for_deletion $rating $sux_number $rox_number $post_replies $post_total>
		[2]==<$replies reply reply reply etc.>
		[3]==<$name>
		[4]==<$topic>
		[5]==<$code>
		[6]==<$comment>
	*/
	$thread_file=fopen($txt_log_file,"r");
	$thread_sz = filesize($txt_log_file);
        if (!($thread_sz == 0))
        {
	       $files_alpha = fread($thread_file, $thread_sz);
	       $files = explode("\n", $files_alpha);
		      $files = array_reverse($files, false);		
	       $number_of_threads = count($files);
	       if ($threads_per_page > $number_of_threads)
	       {
		      $threads_per_page = $number_of_threads;
	       }
	       chdir($dir_data_base);
	       for ($t = ($threads_per_page*$current_page)-$threads_per_page; ($t < ($threads_per_page*$current_page) && ($t < $number_of_threads)); $t++)
	       {
                      if ($files[$t] != "")
                      {
		              $zeefile = $files[$t];
		              $zeefile_sz = filesize($zeefile);
		              $openfile_alpha = fopen($zeefile,"r");
		              $openfile_omega = fread($openfile_alpha, $zeefile_sz);
		              fclose($openfile_alpha);
			             $openfile_omega = str_replace('\\\'', "'", $openfile_omega);
			             $openfile_omega = str_replace("\\\"", "\"", $openfile_omega);
		              $openfile = explode("\n",$openfile_omega,7);
		              $file = $openfile[0];
		              $openfile_num = explode(" ",$openfile[1]);
			             $marked_for_deletion = $openfile_num[0];
			             $rating = $openfile_num[1];
			             $sux_number = $openfile_num[2];
			             $rox_number = $openfile_num[3];
			             $post_replies = $openfile_num[4];
			             $post_total = $openfile_num[5];
		              $replies_num = explode(" ",$openfile[2]);
		              $name = $openfile[3];
		              $topic = $openfile[4];
		              $code = $openfile[5];
		              $comment = nl2br($openfile[6]);
			             $comment = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", $comment);
		              $rating = $rox_number-$sux_number;		
			             if ($name=="") $name=$default_name_ws;
			             if ($topic=="") $topic=$default_subject_title_ws;
			             if ($code==(md5(md5(""))|"")) $code=$default_pass_ws;
			             if ($comment=="") $comment=$default_comment;
		              $owea = explode(".",$files[$t]);
		              $openfile_without_ext = $owea[0];
        		      
		              if ($thread_body_limit != 0)
		              {
			             $comment_split = explode("\n", $comment);
		              }
		              if (($thread_body_limit != 0) && ($comment_split[$thread_body_limit]))
		              {
			             for ($cc = 0; $cc < $thread_body_limit; $cc++)
			             {
				            $pre_comment .= $comment_split[$cc];
			             }
			             $comment = $pre_comment . $full_body_message;
			             $pre_comment = "";
			             $comment_split = "";
		              }
		              list($i_w, $i_h, $i_t, $i_a) = getimagesize("thumb/$openfile_without_ext.jpg");
		              if ($i_w > $i_h) // ex: 853x334
		              {
			             $img_display = 
			             "<img src=\"data/thumb/$openfile_without_ext.jpg\" border=0 align=left width=160 hspace=2 vspace=2 />";
		              }
		              else if ($i_w == $i_h) // ex: 250x250
		              {
			             $img_display = 
			             "<img src=\"data/thumb/$openfile_without_ext.jpg\" border=0 align=left width=160 height=160 hspace=2 vspace=2 />";
		              }
		              else // ex: 263x750
		              {
			             $img_display =
			             "<img src=\"data/thumb/$openfile_without_ext.jpg\" border=0 align=left height=180 hspace=2 vspace=2 />";
		              }
		              // Echo the main thread:
		              echo "<br /><blockquote>
			             <div class=\"topic\">
			             <strong>
			             &nbsp;$topic&nbsp;
			             </strong>
        			     
			             <span class=\"smallwhite\">
			             (
				            $openfile_without_ext&nbsp;
				            By: $name##$code,&nbsp;
				            Rating: $rating,&nbsp;
				            Replies: $post_replies,&nbsp;
				            Posts: $post_total
			             )&nbsp;
			             </span>
        			     
			             <img src=\"images/thread.png\" />
                                                                                                                                                                                        <a class=\"topic\" href=\"reply.php?page=$current_page&style=$style&r=$openfile_without_ext\">
			             &nbsp;Reply&nbsp;
			             </a>
        			     
			             <img src=\"images/kill.png\" />
                                                                                                                                                                                        <a class=\"topic\" href=\"kill.php?page=$current_page&style=$style&r=$openfile_without_ext\">
			             Report
			             </a>
        			     
			             <img src=\"images/rox.png\" />
			             <a class=\"topic\" href=\"rox.php?page=$current_page&style=$style&r=$openfile_without_ext\">
			             Rox
			             </a>
			     
			             <img src=\"images/sux.png\" />
			             <a class=\"topic\" href=\"sux.php?page=$current_page&style=$style&r=$openfile_without_ext\">
			             Sux
			             </a>
			             </div>
			             <table cellpadding=0 cellspacing=5 border=0>
			             <tr>
			             <td width=\"20%\">
			             <a href=\"data/img/$file\">
			             $img_display
			             </a>
			             </td>
        			     
			             <td hspace=5 valign=top>
			             <div class=\"comment\">$comment</div>
			             </td>
			             </tr>
			             </table>";
        			     
		              // Echo the replies:
		              for ($u = 0; $u < count($replies_num)-1; $u++)
		              {
			             $openreply_alpha = fopen($replies_num[$u],"r");
			             $openreply_omega = fread($openreply_alpha, filesize($replies_num[$u]));
			             fclose($openreply_alpha);
        				    
			             $openreply_omega = str_replace('\\\'', "'", $openreply_omega);
			             $openreply_omega = str_replace("\\\"", "\"", $openreply_omega);
			             $openreply = explode("\n",$openreply_omega,7);
        			     
			             $r_file = $openreply[0];
        			     
			             $openreply_num = explode(" ",$openreply[1]);	
			             $r_marked_for_deletion = $openreply_num[0];
			             $r_rating = $openreply_num[1];
			             $r_sux_number = $openreply_num[2];
			             $r_rox_number = $openreply_num[3];
			             $r_post_replies = $openreply_num[4];
			             $r_post_total = $openreply_num[5];
        			     
			             $r_garbage_lol = $openreply[2];
        			     
			             $r_name = $openreply[3];
        			     
			             $r_topic = $openreply[4];
        			     
			             $r_code = $openreply[5];
        			     
			             $r_comment = $openreply[6];
        			     
			             $r_comment = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;", $r_comment);
			             $r_comment = str_replace("\n", "<br />", $r_comment);
			             $r_rating = $r_rox_number-$r_sux_number;     
                                                                                                                                                                                                if ($r_name=="") $r_name=$default_name_ws;                                                                                                         if ($r_topic=="") $r_topic=$default_subject_title_ws;                                                                                              if ($r_code==(md5(md5(""))|"")) $r_code=$default_pass_ws;                                                                                          if ($r_comment=="") $r_comment=$default_comment;                                            
			             // Echoing:
			             echo "<blockquote>
				            <div class=\"replies\">
				            <strong>
				            <div class=\"rtopic\">$r_topic&nbsp;
				            </strong>
        				    
	       			            (
				                   $replies_num[$u]&nbsp;
					           By: $r_name##$r_code,&nbsp;
					           Rating: $r_rating
				            )
				    
				            <img src=\"images/kill.png\" />
				            <a class=\"reply\" href=\"kill.php?page=$current_page&style=$style&r=$replies_num[$u]\">
				            &nbsp;Report&nbsp;
				            </a>
        				    
				            <img src=\"images/rox.png\" />
				            <a class=\"reply\" href=\"rox.php?page=$current_page&style=$style&r=$replies_num[$u]\">
				            &nbsp;Rox&nbsp;
				            </a>
        				    
				            <img src=\"images/sux.png\" />
				            <a class=\"reply\" href=\"sux.php?page=$current_page&style=$style&r=$replies_num[$u]\">
				            &nbsp;Sux&nbsp;
				            </a>                                            
                                            </div>
                                            
                                            <table cellpadding=0 cellspacing=1 border=0>
                                            <tr>
                                            <td width=\"20%\">
                                            <a href=\"data/img/$r_file\">
                                            <img src=\"data/thumb/$replies_num[$u].jpg\" border=0 align=left width=48 height=48 hspace=5 />
                                            </a>
                                            </td>
                                                
                                            <td hspace=5 valign=top>
                                            <div class=\"rcomment\">$r_comment</div>
                                            </td>
                                            </tr>
                                            </table></div></blockquote>";
		              }
                              echo "</blockquote>";
                        }
                }
                // Echo the page numbers again:
                echo "<br /><div align=\"center\" class=\"styles\">";
                for ($p = 1; $p <= $number_of_pages; $p++)
                {
                        echo "<a href=\"up.php?page=$p&style=$style\">";
                        if ($p == $_GET['page'])
                        {
                                echo "<strong>[$p]</strong>";
                        }
                        else
                        {
                                echo "[$p]";
                        }
                        echo "</a>";
                }
                echo "</div>";
        }
	echo $footer;
	echo "</body>";
	echo "</html>";	
?>